Codeforces Round #396 (Div. 2) C. Mahmoud and a Message dp

C. Mahmoud and a Message

题目连接:

http://codeforces.com/contest/766/problem/C

Description

Mahmoud wrote a message s of length n. He wants to send it as a birthday present to his friend Moaz who likes strings. He wrote it on a magical paper but he was surprised because some characters disappeared while writing the string. That’s because this magical paper doesn’t allow character number i in the English alphabet to be written on it in a string of length more than ai. For example, if a1 = 2 he can’t write character ‘a’ on this paper in a string of length 3 or more. String “aa” is allowed while string “aaa” is not.

Mahmoud decided to split the message into some non-empty substrings so that he can write every substring on an independent magical paper and fulfill the condition. The sum of their lengths should be n and they shouldn’t overlap. For example, if a1 = 2 and he wants to send string “aaa”, he can split it into “a” and “aa” and use 2 magical papers, or into “a”, “a” and “a” and use 3 magical papers. He can’t split it into “aa” and “aa” because the sum of their lengths is greater than n. He can split the message into single string if it fulfills the conditions.

A substring of string s is a string that consists of some consecutive characters from string s, strings “ab”, “abc” and “b” are substrings of string “abc”, while strings “acb” and “ac” are not. Any string is a substring of itself.

While Mahmoud was thinking of how to split the message, Ehab told him that there are many ways to split it. After that Mahmoud asked you three questions:

How many ways are there to split the string into substrings such that every substring fulfills the condition of the magical paper, the sum of their lengths is n and they don’t overlap? Compute the answer modulo 109 + 7.
What is the maximum length of a substring that can appear in some valid splitting?
What is the minimum number of substrings the message can be spit in?
Two ways are considered different, if the sets of split positions differ. For example, splitting “aa|a” and “a|aa” are considered different splittings of message “aaa”.

Input

The first line contains an integer n (1 ≤ n ≤ 103) denoting the length of the message.

The second line contains the message s of length n that consists of lowercase English letters.

The third line contains 26 integers a1, a2, …, a26 (1 ≤ ax ≤ 103) — the maximum lengths of substring each letter can appear in.

Output

Print three lines.

In the first line print the number of ways to split the message into substrings and fulfill the conditions mentioned in the problem modulo 109  +  7.

In the second line print the length of the longest substring over all the ways.

In the third line print the minimum number of substrings over all the ways.

Sample Input

3
aab
2 3 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1

Sample Output

3
2
2

Hint

题意

给你一个长度为n的串,然后再给你26个数num[i]。

你现在要分割这个串,合法的分割是:如果某一个分割存在字母i,那么要么满足len<=num[i]才行,就是这个分割的长度应该小于num[i]

然后让你输出:

(1)分割的方式数量 mod 1e9+7

(2)合法的分割中,最长的分割长度是多少?

(3)最少的分割次数是多少?

题解:

数据范围只有1000,基本的动态规划,可以当成三个问题来做就好了。

数据范围出成1e5可能要好玩得多。

具体看代码吧,三个DP方程大同小异。

代码

#include<bits/stdc++.h>
using namespace std;
const int mod = 1e9+7;
const int maxn = 2e3+7;
string s;
int num[26],n;
int sum[maxn][26];
int dp1[maxn];
int dp2[maxn];
int dp3[maxn];
bool check(int l,int r){
    for(int i=0;i<26;i++){
        int L,R;
        if(l==0)L=0;
        else L=sum[l-1][i];
        R=sum[r][i];
        if(R-L&&r-l+1>num[i])return false;
    }
    return true;
}
int main()
{
    scanf("%d",&n);
    cin>>s;
    for(int i=0;i<maxn;i++)
        dp3[i]=1e9;
    for(int i=0;i<26;i++)
        cin>>num[i];
    for(int i=0;i<s.size();i++){
        if(i==0)sum[i][s[i]-'a']=1;
        else{
            for(int j=0;j<26;j++)
                sum[i][j]=sum[i-1][j];
            sum[i][s[i]-'a']++;
        }
    }
    for(int i=0;i<n;i++){
        if(check(0,i)){
            dp1[i]=1;
            dp2[i]=max(dp2[i],i+1);
            dp3[i]=1;
        }
        for(int j=1;j<=i;j++){
            if(check(j,i))
            {
                dp1[i]=(dp1[i]+dp1[j-1])%mod;
                dp2[i]=max(dp2[i],dp2[j-1]);
                dp2[i]=max(dp2[i],i-j+1);
                dp3[i]=min(dp3[i],dp3[j-1]+1);
            }
        }
    }
    cout<<dp1[n-1]<<endl;
    cout<<dp2[n-1]<<endl;
    cout<<dp3[n-1]<<endl;
}
    原文作者:qscqesze
    原文地址: https://www.cnblogs.com/qscqesze/p/6378325.html
    本文转自网络文章,转载此文章仅为分享知识,如有侵权,请联系博主进行删除。
点赞